/*

Copyright 2007 Jakob Dangarden

 This file is part of Usurper.

    Usurper is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Usurper is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Usurper; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "files.h"

void Reset_Waist(void)
{
            /*typ av objekt :
                             1. head
                             2. body
                             3. arms
                             4. hands
                             5. fingers
                             6. legs
                             7. feets
                             8. waist
                             9. neck
                            10. face
                            11. shield
                            12. mat
                            13. dryck
                            14. vapen
                            15. around body */

 Add_Object("Grass Skirt",   /*name*/
            Waist,     /*typ*/
            500,       /*vrde i gold*/
            0,         /*ka/minska hps*/
            0,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            1,         /*ka armor vrde*/
            0,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            25,        /*max level att hittas i dngs*/
            "Doesn't seem to be worth much.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Leather Skirt",   /*name*/
            Waist,     /*typ*/
            1500,      /*vrde i gold*/
            0,         /*ka/minska hps*/
            1,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            3,         /*ka armor vrde*/
            0,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            15,        /*max level att hittas i dngs*/
            "Short \"teenager\" model",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Heavy Leather Skirt",   /*name*/
            Waist,     /*typ*/
            5500,      /*vrde i gold*/
            5,         /*ka/minska hps*/
            0,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            5,         /*ka armor vrde*/
            0,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            10,        /*min level att hittas i dngs*/
            30,        /*max level att hittas i dngs*/
            "Teeny Boppers favourite. Long model with pink buttons!",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Ivory Belt",   /*name*/
            Waist,     /*typ*/
            8900,      /*vrde i gold*/
            0,         /*ka/minska hps*/
            0,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            0,         /*ka armor vrde*/
            1,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            false,     /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            99,        /*max level att hittas i dngs*/
            "You see nothing special.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Monks Belt",   /*name*/
            Waist,     /*typ*/
            7400,      /*vrde i gold*/
            -5,        /*ka/minska hps*/
            -5,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            15,        /*ka wisdom*/
            15,        /*ka mana*/
            0,         /*ka armor vrde*/
            1,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            false,     /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            5,         /*min level att hittas i dngs*/
            15,        /*max level att hittas i dngs*/
            "You see nothing special.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Yellow Belt",   /*name*/
            Waist,     /*typ*/
            25,         /*vrde i gold*/
            -2,        /*ka/minska hps*/
            -2,        /*ka stamina*/
            -2,        /*ka agility*/
            -2,        /*ka charisma*/
            -2,        /*ka dexterity*/
            -2,        /*ka wisdom*/
            -2,        /*ka mana*/
            -2,        /*ka armor vrde*/
            -2,        /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            true,      /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            99,        /*max level att hittas i dngs*/
            "You see nothing special.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Copper Belt",   /*name*/
            Waist,     /*typ*/
            90000,     /*vrde i gold*/
            35,        /*ka/minska hps*/
            2,         /*ka stamina*/
            2,         /*ka agility*/
            2,         /*ka charisma*/
            2,         /*ka dexterity*/
            2,         /*ka wisdom*/
            2,         /*ka mana*/
            2,         /*ka armor vrde*/
            2,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            false,     /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            50,        /*min level att hittas i dngs*/
            99,        /*max level att hittas i dngs*/
            "The Great Copper Belt.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

 Add_Object("Grass Belt",   /*name*/
            Waist,     /*typ*/
            150,       /*vrde i gold*/
            0,         /*ka/minska hps*/
            0,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            1,         /*ka armor vrde*/
            0,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Blindness, /*kurerar*/
            true,      /*finnas i shoppen*/
            true,      /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            15,        /*max level att hittas i dngs*/
            "You see nothing special.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/

  Add_Object("Golden Apron",   /*name*/
             Waist,     /*typ*/
             25000,     /*vrde i gold*/
             30,        /*ka/minska hps*/
             0,         /*ka stamina*/
             0,         /*ka agility*/
             0,         /*ka charisma*/
             0,         /*ka dexterity*/
             0,         /*ka wisdom*/
             0,         /*ka mana*/
             5,         /*ka armor vrde*/
             0,         /*ka attack vrde*/
             "",        /*gd av?*/
             false,     /*bara EN i spelet*/
             Nothing,   /*kurerar*/
             true,      /*finnas i shoppen*/
             true,      /*kunna hittas i dungeons?*/
             false,     /*cursed item?*/
             70,        /*min level att hittas i dngs*/
             79,        /*max level att hittas i dngs*/
             "You see nothing special.",
             "",        /*normal beskrivning 2*/
             "",        /*normal beskrivning 3*/
             "",        /*normal beskrivning 4*/
             "",        /*normal beskrivning 5*/
             "",        /*detaljerad beskrivning 1*/
             "",        /*detaljerad beskrivning 2*/
             "",        /*detaljerad beskrivning 3*/
             "",        /*detaljerad beskrivning 4*/
             "",        /*detaljerad beskrivning 5*/
             7,         /*ka strength*/
             7,         /*ka defence*/
             20);       /*strength demanded to use object*/

 Add_Object("Pink Skirt",   /*name*/
            Waist,     /*typ*/
            2500,      /*vrde i gold*/
            0,         /*ka/minska hps*/
            0,         /*ka stamina*/
            0,         /*ka agility*/
            0,         /*ka charisma*/
            0,         /*ka dexterity*/
            0,         /*ka wisdom*/
            0,         /*ka mana*/
            3,         /*ka armor vrde*/
            0,         /*ka attack vrde*/
            "",        /*gd av?*/
            false,     /*bara EN i spelet*/
            Nothing,   /*kurerar*/
            true,      /*finnas i shoppen*/
            false,     /*kunna hittas i dungeons?*/
            false,     /*cursed item?*/
            1,         /*min level att hittas i dngs*/
            99,        /*max level att hittas i dngs*/
            "You see nothing special.",
            "",        /*normal beskrivning 2*/
            "",        /*normal beskrivning 3*/
            "",        /*normal beskrivning 4*/
            "",        /*normal beskrivning 5*/
            "",        /*detaljerad beskrivning 1*/
            "",        /*detaljerad beskrivning 2*/
            "",        /*detaljerad beskrivning 3*/
            "",        /*detaljerad beskrivning 4*/
            "",        /*detaljerad beskrivning 5*/
            0,         /*ka strength*/
            0,         /*ka defence*/
            0);        /*strength demanded to use object*/


}
